  MEMBER('test.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
test_BC0:DctInit    PROCEDURE
test_BC0:DctKill    PROCEDURE
test_BC0:FilesInit  PROCEDURE
  END

Hide:Access:Vault    CLASS(FileManager),TYPE               ! FileManager for Vault
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Vault    CLASS(RelationManager),TYPE           ! RelationManager for Vault
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Vault   &Hide:Access:Vault,AUTO,THREAD
_Hide:Relate:Vault   &Hide:Relate:Vault,AUTO,THREAD


test_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Vault &= NEW(Hide:Access:Vault)
  _Hide:Relate:Vault &= NEW(Hide:Relate:Vault)
  Relate:Vault &= _Hide:Relate:Vault


test_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Vault.Init


test_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Vault.Kill
  DISPOSE(_Hide:Relate:Vault)


Hide:Relate:Vault.Init PROCEDURE
  CODE
  _Hide:Access:Vault.Init
  SELF.Init(Access:Vault,1)


Hide:Access:Vault.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= VAU:Record
  SELF.FileNameValue = 'Vault'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Vault
  PARENT.Init
  Access:Vault &= SELF


Hide:Access:Vault.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Vault &= NULL                                     ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Vault.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Vault,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(VAU:VaultID,'VAU:VaultID',1)
    SELF.AddKey(VAU:APPidKey,'VAU:APPidKey',0)
    SELF.AddKey(VAU:DateKey,'VAU:DateKey',0)
    SELF.AddKey(VAU:DeveloperKey,'VAU:DeveloperKey',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Vault.Kill PROCEDURE

  CODE
  _Hide:Access:Vault.Kill                                  ! Kill the file manager
  PARENT.Kill
  Relate:Vault &= NULL                                     ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Vault)                              ! destroy the file manager

